Subject: bug#43830: keyboard layout handling incompatible with rest of the OS

From: Eli Zaretskii <[email-masked]>
Date: Tue, 06 Oct 2020 20:26:02 +0300

> From: Paul Pogonyshev <[email-masked]>
> Date: Tue, 6 Oct 2020 17:34:34 +0200
> 
> I use English and Russian keyboard layouts. For every single application I don't need to care which layout is
> currently selected for shortcuts, e.g. Ctrl+S and Ctrl+Ы do the same (S and Ы are on the same physical
> key). Of course, in Emacs it doesn't work this way: C-s triggers Isearch, but C-ы "is undefined".

Do you know how to retrieve the key code corresponding to the English
keyboard layout when the active layout is something else, like
Russian?  Does someone else here know?

Or maybe the keyboard driver can be configured to return ASCII
characters when the Ctrl key is held, even when the layout is
non-English?

What Emacs does, AFAICT, when a key press event comes in is call the
Xlib function that returns the character produced by the keyboard, and
that character depends on the current keyboard layout.  We then add
the modifier keys to that character.  I don't see the "original"
English-layout character available anywhere in that code, but maybe
I'm missing something.

A workaround is to bind C-ы to the same command as C-s (and similarly
with other combinations that matter).